#ifndef EFL_GENERATED_ECORE_AUDIO_IN_SNDFILE_HH
#define EFL_GENERATED_ECORE_AUDIO_IN_SNDFILE_HH

#include <Eo.h>
#include <Eo.hh>

extern "C"
{
#include "ecore_audio_in_sndfile.eo.h"
}

#include "ecore_audio_in.eo.hh"

struct ecore_audio_in_sndfile
      : ecore_audio_in
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit ecore_audio_in_sndfile(Eo* eo)
      : ecore_audio_in(eo)
   {}

   ecore_audio_in_sndfile(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : ecore_audio_in_sndfile(_c0(_p))
   {}

   /// @brief Copy Constructor.
   ///
   ecore_audio_in_sndfile(ecore_audio_in_sndfile const& other)
      : ecore_audio_in(eo_ref(other._eo_ptr()))
   {}

   ~ecore_audio_in_sndfile() {}

   static Eo_Class const* _eo_class()
   {
      return(ECORE_AUDIO_OBJ_IN_SNDFILE_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_custom(ECORE_AUDIO_OBJ_IN_SNDFILE_CLASS, _p._eo_raw, eo_constructor());
   }

};
namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::ecore_audio_in_sndfile >
{
   template <typename T>
   struct type
   {
   };
};


template<>
struct operation_description_class_size< ::ecore_audio_in_sndfile >
{
   static const int value = 0;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::ecore_audio_in_sndfile>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   return 0;
}
inline void
call_constructor(tag< ::ecore_audio_in_sndfile >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::ecore_audio_in_sndfile, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

template<>
struct extension_inheritance< ::ecore_audio_in_sndfile>
{
   template <typename T>
   struct type
   {
      operator ::ecore_audio_in_sndfile() const
      {
         return ::ecore_audio_in_sndfile(eo_ref(static_cast<T const*>(this)->_eo_ptr()));
      }

   };
};

inline Eo_Class const* get_eo_class(tag<::ecore_audio_in_sndfile>)
{
   return (ECORE_AUDIO_OBJ_IN_SNDFILE_CLASS);
}

} } }
#endif // EFL_GENERATED_ECORE_AUDIO_IN_SNDFILE_HH

